/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// OnCallPlayDone - Invoked when a play command is completed.    OnCallPlayFilesDone - Invoked when play files command is completed.    OnCallPlayRecordDone - Invoked when a play record command is completed.    OnCallRecordDone - Invoked when a record command is completed.    OnCallGetDigitsDone - Invoked when a get digits command is completed.    OnCallSendDigitsDone - Invoked when a send digits command is completed.    OnCallSpeakDone - Invoked when a speak or speak ssml command is completed.
    /// </summary>
    [DataContract]
        public partial class CallMediaSubscriptions :  IEquatable<CallMediaSubscriptions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CallMediaSubscriptions" /> class.
        /// </summary>
        /// <param name="onCallPlayDone">onCallPlayDone.</param>
        /// <param name="onCallPlayFilesDone">onCallPlayFilesDone.</param>
        /// <param name="onCallPlayRecordDone">onCallPlayRecordDone.</param>
        /// <param name="onCallRecordDone">onCallRecordDone.</param>
        /// <param name="onCallGetDigitsDone">onCallGetDigitsDone.</param>
        /// <param name="onCallSendDigitsDone">onCallSendDigitsDone.</param>
        /// <param name="onCallSpeakDone">onCallSpeakDone.</param>
        public CallMediaSubscriptions(string onCallPlayDone = default(string), string onCallPlayFilesDone = default(string), string onCallPlayRecordDone = default(string), string onCallRecordDone = default(string), string onCallGetDigitsDone = default(string), string onCallSendDigitsDone = default(string), string onCallSpeakDone = default(string))
        {
            this.OnCallPlayDone = onCallPlayDone;
            this.OnCallPlayFilesDone = onCallPlayFilesDone;
            this.OnCallPlayRecordDone = onCallPlayRecordDone;
            this.OnCallRecordDone = onCallRecordDone;
            this.OnCallGetDigitsDone = onCallGetDigitsDone;
            this.OnCallSendDigitsDone = onCallSendDigitsDone;
            this.OnCallSpeakDone = onCallSpeakDone;
        }
        
        /// <summary>
        /// Gets or Sets OnCallPlayDone
        /// </summary>
        [DataMember(Name="onCallPlayDone", EmitDefaultValue=false)]
        public string OnCallPlayDone { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayFilesDone
        /// </summary>
        [DataMember(Name="onCallPlayFilesDone", EmitDefaultValue=false)]
        public string OnCallPlayFilesDone { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayRecordDone
        /// </summary>
        [DataMember(Name="onCallPlayRecordDone", EmitDefaultValue=false)]
        public string OnCallPlayRecordDone { get; set; }

        /// <summary>
        /// Gets or Sets OnCallRecordDone
        /// </summary>
        [DataMember(Name="onCallRecordDone", EmitDefaultValue=false)]
        public string OnCallRecordDone { get; set; }

        /// <summary>
        /// Gets or Sets OnCallGetDigitsDone
        /// </summary>
        [DataMember(Name="onCallGetDigitsDone", EmitDefaultValue=false)]
        public string OnCallGetDigitsDone { get; set; }

        /// <summary>
        /// Gets or Sets OnCallSendDigitsDone
        /// </summary>
        [DataMember(Name="onCallSendDigitsDone", EmitDefaultValue=false)]
        public string OnCallSendDigitsDone { get; set; }

        /// <summary>
        /// Gets or Sets OnCallSpeakDone
        /// </summary>
        [DataMember(Name="onCallSpeakDone", EmitDefaultValue=false)]
        public string OnCallSpeakDone { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CallMediaSubscriptions {\n");
            sb.Append("  OnCallPlayDone: ").Append(OnCallPlayDone).Append("\n");
            sb.Append("  OnCallPlayFilesDone: ").Append(OnCallPlayFilesDone).Append("\n");
            sb.Append("  OnCallPlayRecordDone: ").Append(OnCallPlayRecordDone).Append("\n");
            sb.Append("  OnCallRecordDone: ").Append(OnCallRecordDone).Append("\n");
            sb.Append("  OnCallGetDigitsDone: ").Append(OnCallGetDigitsDone).Append("\n");
            sb.Append("  OnCallSendDigitsDone: ").Append(OnCallSendDigitsDone).Append("\n");
            sb.Append("  OnCallSpeakDone: ").Append(OnCallSpeakDone).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CallMediaSubscriptions);
        }

        /// <summary>
        /// Returns true if CallMediaSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of CallMediaSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CallMediaSubscriptions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OnCallPlayDone == input.OnCallPlayDone ||
                    (this.OnCallPlayDone != null &&
                    this.OnCallPlayDone.Equals(input.OnCallPlayDone))
                ) && 
                (
                    this.OnCallPlayFilesDone == input.OnCallPlayFilesDone ||
                    (this.OnCallPlayFilesDone != null &&
                    this.OnCallPlayFilesDone.Equals(input.OnCallPlayFilesDone))
                ) && 
                (
                    this.OnCallPlayRecordDone == input.OnCallPlayRecordDone ||
                    (this.OnCallPlayRecordDone != null &&
                    this.OnCallPlayRecordDone.Equals(input.OnCallPlayRecordDone))
                ) && 
                (
                    this.OnCallRecordDone == input.OnCallRecordDone ||
                    (this.OnCallRecordDone != null &&
                    this.OnCallRecordDone.Equals(input.OnCallRecordDone))
                ) && 
                (
                    this.OnCallGetDigitsDone == input.OnCallGetDigitsDone ||
                    (this.OnCallGetDigitsDone != null &&
                    this.OnCallGetDigitsDone.Equals(input.OnCallGetDigitsDone))
                ) && 
                (
                    this.OnCallSendDigitsDone == input.OnCallSendDigitsDone ||
                    (this.OnCallSendDigitsDone != null &&
                    this.OnCallSendDigitsDone.Equals(input.OnCallSendDigitsDone))
                ) && 
                (
                    this.OnCallSpeakDone == input.OnCallSpeakDone ||
                    (this.OnCallSpeakDone != null &&
                    this.OnCallSpeakDone.Equals(input.OnCallSpeakDone))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OnCallPlayDone != null)
                    hashCode = hashCode * 59 + this.OnCallPlayDone.GetHashCode();
                if (this.OnCallPlayFilesDone != null)
                    hashCode = hashCode * 59 + this.OnCallPlayFilesDone.GetHashCode();
                if (this.OnCallPlayRecordDone != null)
                    hashCode = hashCode * 59 + this.OnCallPlayRecordDone.GetHashCode();
                if (this.OnCallRecordDone != null)
                    hashCode = hashCode * 59 + this.OnCallRecordDone.GetHashCode();
                if (this.OnCallGetDigitsDone != null)
                    hashCode = hashCode * 59 + this.OnCallGetDigitsDone.GetHashCode();
                if (this.OnCallSendDigitsDone != null)
                    hashCode = hashCode * 59 + this.OnCallSendDigitsDone.GetHashCode();
                if (this.OnCallSpeakDone != null)
                    hashCode = hashCode * 59 + this.OnCallSpeakDone.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
